%%
%% This is file `njuthesis.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% njuthesis.dtx  (with options: `class')
%% 
%% Copyright (C) 2021
%% by Nanjing University Linux User Group <nju.lug@yaoge123.cn>
%% 
%% This file may be distributed and/or modified under the conditions of
%% the LaTeX Project Public License, either version 1.3 of this license
%% or (at your option) any later version.  The latest version of this
%% license is in:
%% 
%%    http://www.latex-project.org/lppl.txt
%% 
%% and version 1.3 or later is part of all distributions of LaTeX version
%% 2005/12/01 or later.
%% 
%% To produce the documentation run the original source files ending with `.dtx'
%% through XeTeX.
%% 
\NeedsTeXFormat{LaTeX2e}
\RequirePackage{expl3}
\GetIdInfo  $Id: njuthesis.dtx 0.11.0 2021-10-01 19:00:00 +0800  NJU LUG <nju.lug@yaoge123.cn> $
  { Thesis template for Nanjing University }
\ProvidesExplClass{njuthesis}
{\ExplFileDate}{\ExplFileVersion}{\ExplFileDescription}
\cs_new_protected:Npn \__nju_define_name:nn #1#2
  { \tl_const:cn { c__nju_name_ #1 _tl } {#2} }
\cs_new_protected:Npn \__nju_define_name:nnn #1#2#3
  {
    \tl_const:cn { c__nju_name_ #1    _tl } {#2}
    \tl_const:cn { c__nju_name_ #1 _en_tl } {#3}
  }
\clist_map_inline:nn
  {
    { pdf_creator     } { LaTeX~ with~ njuthesis~ class },
  }
  { \__nju_define_name:nn #1 }
\clist_map_inline:nn
  {
    { keywords } { 关键词：    } { Keywords:         },
  }
  { \__nju_define_name:nnn #1 }
\RequirePackage{xparse,xtemplate,l3keys2e}
\tl_new:N \l__nju_info_degree_tl
\tl_new:N \l__nju_info_type_tl
\tl_new:N \g__nju_latin_fontset_tl
\tl_new:N \g__nju_cjk_fontset_tl
\keys_define:nn { nju }
{
  degree            .choices:nn   =
  { ug, mg, mg, phd }
  { \tl_set_eq:NN \l__nju_info_degree_tl \l_keys_choice_tl },
  degree            .initial:n    =   ug,
  type              .choices:nn   =
  { thesis, design }
  { \tl_set_eq:NN \l__nju_info_type_tl   \l_keys_choice_tl },
  type              .initial:n    =   thesis,
  nlcover           .bool_set:N   =   \g__nju_nlcover_bool,
  nlcover           .initial:n    =   false,
  customlatinfont   .choices:nn   =
  { gyre, macos, windows, none }
  { \tl_set_eq:NN \g__nju_latin_fontset_tl \l_keys_choice_tl },
  customchinesefont .choices:nn   =
  { fandol, founder, macos, noto, windows, none }
  { \tl_set_eq:NN \g__nju_cjk_fontset_tl   \l_keys_choice_tl },
}
\ProcessKeysOptions { nju }
\keys_define:nn { nju }
{
  info.meta:nn = { nju / info } { #1 }
}
\keys_define:nn { nju / info }
{
  titlea            .tl_set:N = \l__nju_info_title_a_tl,
  titleb            .tl_set:N = \l__nju_info_title_b_tl,
  titlec            .tl_set:N = \l__nju_info_title_c_tl,
  title*            .tl_set:N = \l__nju_info_title_en_tl,
keywords         .clist_set:N = \l__nju_info_keywords_clist,
keywords*        .clist_set:N = \l__nju_info_keywords_en_clist,
  grade             .tl_set:N = \l__nju_info_grade_tl,
  student-id        .tl_set:N = \l__nju_info_id_tl,
  author            .tl_set:N = \l__nju_info_author_tl,
  author*           .tl_set:N = \l__nju_info_author_en_tl,
  department        .tl_set:N = \l__nju_info_dept_tl,
  department*       .tl_set:N = \l__nju_info_dept_en_tl,
  major             .tl_set:N = \l__nju_major_tl,
  major*            .tl_set:N = \l__nju_major_en_tl,
  field             .tl_set:N = \l__nju_field_tl,
  field*            .tl_set:N = \l__nju_field_en_tl,
  supervisora       .tl_set:N = \l__nju_info_supv_a_tl,
  supervisora*      .tl_set:N = \l__nju_info_supv_a_en_tl,
  supervisora-title .tl_set:N = \l__nju_info_supv_a_title_tl,
  supervisora-title*.tl_set:N = \l__nju_info_supv_a_title_en_tl,
  supervisorb       .tl_set:N = \l__nju_info_supv_b_tl,
  supervisorb*      .tl_set:N = \l__nju_info_supv_b_en_tl,
  supervisorb-title .tl_set:N = \l__nju_info_supv_b_title_tl,
  supervisorb-title*.tl_set:N = \l__nju_info_supv_b_title_en_tl,
  % 提交日期
  submit-date       .tl_set:N = \l__nju_submit_date_tl,
  submit-date*      .tl_set:N = \l__nju_submit_date_en_tl,
  defend-date       .tl_set:N = \l__nju_defend_date_tl,
  chairman          .tl_set:N = \l__nju_info_chairman_tl,
  reviewer       .clist_set:N = \l__nju_info_reviewer_clist,
  clc               .tl_set:N = \l__nju_info_clc_tl,
  secret-level      .tl_set:N = \l__nju_info_seclv_tl,
  udc               .tl_set:N = \l__nju_info_udc_tl,
  supervisor-contact.tl_set:N = \l__nju_info_supv_cont_tl,
}
\NewDocumentCommand \njusetup { m }
{ \keys_set:nn { nju } { #1 } }
\LoadClass[
  a4paper,
  twoside,
  UTF8,
  scheme=chinese,
  linespread=1.625,
  fontset=none,
  zihao=-4
  ]{ctexbook}[2018/04/01]
\RequirePackage
{
  geometry,
  caption,
  floatrow,
  setspace,
  lastpage,
  emptypage,
  fancyhdr,
}
\RequirePackage[titles]{tocloft}
\RequirePackage[hyphens]{url} % generate better linebreaks in the url
\RequirePackage{siunitx} % 用于书写单位符号
\RequirePackage[version=4]{mhchem} % 用于绘制分子式
\RequirePackage{hologo}
\sys_if_engine_xetex:T
{
    \RequirePackage{xeCJKfntef,microtype}
    \newcommand{\njuline}[1]{\CJKunderline{#1}}
}
\sys_if_engine_luatex:T
{
    \RequirePackage{lua-ul,dashundergaps}
    \newcommand{\njuline}[1]{\underLine{#1}\null}
}
\RequirePackage{amsmath,amsthm,mathtools,thmtools}
\RequirePackage[
    warnings-off={
        mathtools-colon,
        mathtools-overbracket}
        ]{unicode-math}
\RequirePackage{graphicx,subcaption,wrapfig,tikz}
\DeclareGraphicsExtensions{.pdf,.eps,.jpg,.png}
\RequirePackage{booktabs,multirow,multicol,listings,enumitem}
\RequirePackage[hidelinks,bookmarksnumbered=true]{hyperref}
\RequirePackage[capitalise,nameinlink,noabbrev]{cleveref}
\RequirePackage{njuvisual}
\RequirePackage{blindtext,zhlipsum}
\bool_new:N \g__nju_load_system_fontset_bool
\tl_if_empty:NTF \g__nju_latin_fontset_tl
  { \bool_gset_true:N \g__nju_load_system_fontset_bool }
{
  \tl_if_empty:NT \g__nju_cjk_fontset_tl
    { \bool_gset_true:N \g__nju_load_system_fontset_bool }
}
\bool_if:NT \g__nju_load_system_fontset_bool
{
  \sys_if_platform_windows:TF
  {
    \tl_set:Nn \g__nju_latin_fontset_tl { windows }
    \tl_set:Nn \g__nju_cjk_fontset_tl   { windows }
  }
  {
    \ctex_if_platform_macos:TF
    {
      \tl_set:Nn \g__nju_latin_fontset_tl { macos }
      \tl_set:Nn \g__nju_cjk_fontset_tl   { macos }
    }
    {
      \tl_set:Nn \g__nju_latin_fontset_tl { gyre }
      \tl_set:Nn \g__nju_cjk_fontset_tl { fandol }
    }
  }
}
\cs_new_protected:Npn \__nju_load_latin_font_windows:
{
  \setmainfont{Times~New~Roman}
  \setsansfont{Arial}
  \setmonofont{Courier~New}[Scale=MatchLowercase]
}
\cs_new_protected:Npn \__nju_load_latin_font_macos:
{
  \setmainfont{Times~New~Roman}
  \setsansfont{Arial}
  \setmonofont{Menlo}[Scale=MatchLowercase]
}
\cs_new_protected:Npn \__nju_load_latin_font_gyre:
{
  \setmainfont{texgyretermes}[
    Extension=.otf,
    UprightFont=*-regular,
    BoldFont=*-bold,
    ItalicFont=*-italic,
    BoldItalicFont=*-bolditalic]
  \setsansfont{texgyreheros}[
    Extension=.otf,
    UprightFont=*-regular,
    BoldFont=*-bold,
    ItalicFont=*-italic,
    BoldItalicFont=*-bolditalic]
  \setmonofont{texgyrecursor}[
    Extension=.otf,
    UprightFont=*-regular,
    BoldFont=*-bold,
    ItalicFont=*-italic,
    BoldItalicFont=*-bolditalic,
    Scale=MatchLowercase,
    Ligatures=CommonOff]
}
\cs_new_protected:Npn \__nju_load_cjk_font_windows:
{
  \setCJKmainfont{SimSun}[
    AutoFakeBold=2.17,
    ItalicFont=KaiTi]
  \setCJKsansfont{SimHei}
  \setCJKmonofont{FangSong}
  \setCJKfamilyfont{zhsong}{SimSun}[AutoFakeBold=2.17]
  \setCJKfamilyfont{zhhei}{SimHei}
  \setCJKfamilyfont{zhfs}{FangSong}
  \setCJKfamilyfont{zhkai}{KaiTi}[AutoFakeBold=2.17]
  % \setCJKfamilyfont{zhnewhei}{Microsoft~YaHei}[
  %   BoldFont=Microsoft~YaHei~Bold]
}
\cs_new_protected:Npn \__nju_load_cjk_font_macos:
{
  % 移除 does not contain script "CJK" 警告
  \msg_redirect_name:nnn {fontspec} {no-script} {info}
  \setCJKmainfont{Songti~SC~Light}[
    BoldFont=Songti~SC~Bold,
    ItalicFont=Kaiti~SC,
    BoldItalicFont=Kaiti~SC~Bold]
  \setCJKsansfont{Heiti~SC~Light}[BoldFont=Heiti~SC~Medium]
  \setCJKmonofont{STFangsong}
  \setCJKfamilyfont{zhsong}{Songti~SC~Light}[BoldFont=Songti~SC~Bold]
  \setCJKfamilyfont{zhhei}{Heiti~SC~Light}[BoldFont=Heiti~SC~Medium]
  \setCJKfamilyfont{zhfs}{STFangsong}
  \setCJKfamilyfont{zhkai}{Kaiti~SC}[BoldFont=Kaiti~SC~Bold]
  \setCJKfamilyfont{zhnewhei}{PingFang~SC}
}
\cs_new_protected:Npn \__nju_load_cjk_font_fandol:
{
  % 移除 does not contain script "CJK" 警告
  \msg_redirect_name:nnn {fontspec} {no-script} {info}
  \setCJKmainfont{FandolSong-Regular}[
    Extension=.otf,
    BoldFont=FandolSong-Bold,
    ItalicFont=FandolKai-Regular]
  \setCJKsansfont{FandolHei-Regular}[
    Extension=.otf,
    BoldFont=FandolHei-Bold]
  \setCJKmonofont{FandolFang-Regular}[Extension=.otf]
  \setCJKfamilyfont{zhsong}{FandolSong-Regular}[
    Extension=.otf,
    BoldFont=FandolSong-Bold]
  \setCJKfamilyfont{zhhei}{FandolHei-Regular}[
    Extension=.otf,
    BoldFont=FandolHei-Bold]
  \setCJKfamilyfont{zhfs}{FandolFang-Regular}[Extension=.otf]
  \setCJKfamilyfont{zhkai}{FandolKai-Regular}[
    Extension=.otf,
    AutoFakeBold=2.17]
}
\cs_new_protected:Npn \__nju_load_cjk_font_founder:
{
  \setCJKmainfont{FZSSK}[% 方正书宋
    Extension=.ttf,
    BoldFont=FZXBSK,% 方正小标宋
    ItalicFont=FZKTK]% 方正楷体
  \setCJKsansfont{FZXH1K}[% 方正细黑一
    Extension=.ttf,
    BoldFont=FZHTK]% FZHTK 方正黑体
  \setCJKmonofont{FZFSK}[Extension=.ttf]% 方正仿宋
  \setCJKfamilyfont{zhsong}
    {FZSSK}[
      Extension=.ttf,
      BoldFont=FZXBSK]
  \setCJKfamilyfont{zhhei}
    {FZHTK}[
      Extension=.ttf,
      AutoFakeBold=2.17]
  \setCJKfamilyfont{zhfs}
    {FZFSK}[Extension=.ttf]
  \setCJKfamilyfont{zhkai}
    {FZKTK}[Extension=.ttf]
  % \setCJKfamilyfont{zhnewhei}
  %   {FZYouHK_508R}[% 方正悠黑508R
  %     Extension=.ttf,
  %     BoldFont=FZYouHK_511M]% 方正悠黑511M
}
\cs_new_protected:Npn \__nju_load_cjk_font_noto:
{
  % 思源宋体
  \setCJKmainfont[
    UprightFont=NotoSerifSC-Regular,
    BoldFont=NotoSerifSC-Bold,
    ItalicFont=NotoSerifSC-Regular,
    BoldItalicFont=NotoSerifSC-Bold,
    ItalicFeatures=FakeSlant,
    BoldItalicFeatures=FakeSlant]{Noto~Serif~SC}

  % 思源黑体
  \setCJKsansfont[
    UprightFont=NotoSansSC-Regular,
    BoldFont=NotoSansSC-Bold,
    ItalicFont=NotoSansSC-Regular,
    BoldItalicFont=NotoSansSC-Bold,
    ItalicFeatures=FakeSlant,
    BoldItalicFeatures=FakeSlant]{Noto~Sans~SC}

  \setCJKmonofont{FZFSK}[Extension=.ttf]% 方正仿宋

  \setCJKfamilyfont{zhsong}{Noto~Serif~SC}
  \setCJKfamilyfont{zhhei}{Noto~Sans~SC}
  \setCJKfamilyfont{zhfs}
    {FZFSK}[Extension=.ttf]
  \setCJKfamilyfont{zhkai}
    {FZKTK}[Extension=.ttf]
}
\cs_new_protected:Npn \__nju_load_font:
{
  \use:c { __nju_load_latin_font_ \g__nju_latin_fontset_tl : }
  \use:c { __nju_load_cjk_font_   \g__nju_cjk_fontset_tl   : }
  \NewDocumentCommand\songti{}{\CJKfamily{zhsong}}
  \NewDocumentCommand\heiti{}{\CJKfamily{zhhei}}
  \NewDocumentCommand\fangsong{}{\CJKfamily{zhfs}}
  \NewDocumentCommand\kaishu{}{\CJKfamily{zhkai}}
}
\__nju_load_font:
\setmathfont{XITSMath-Regular}[
  BoldFont = XITSMath-Bold,
  Extension = .otf]
\setmathfont{latinmodern-math.otf}[range={cal,bb,frak}]
\geometry{
  vmargin    = 2.5 cm,
  hmargin    = 3.2 cm,
}
\fancypagestyle{njuplain}{
   \fancyhead{}
   \fancyfoot[C]{\zihao{5}\thepage}
}
\fancypagestyle{njuheadings}{%
   \fancyhead{}
   \fancyfoot[C]{\zihao{5}\thepage}
}
\str_if_eq:NNTF {\l__nju_info_degree_tl} { ug }
{
  % the header line
  \tl_set:Nn \headrulewidth {0pt}
  % the footer line
  \tl_set:Nn \footrulewidth {0pt}
  \AtBeginDocument{\pagestyle{njuplain}\flushbottom} % 本科无页眉页脚
}
{
  % the header line
  \tl_set:Nn \headrulewidth {1pt}
  % the footer line
  \tl_set:Nn \footrulewidth {0pt}
  \setlength{\headheight}{20pt}
  \AtBeginDocument{\pagestyle{fancy}\flushbottom} % 研究生有页眉页脚
}
\ctexset{
    chapter/format = \zihao{4}\heiti\centering\selectfont,
    chapter/beforeskip = 10pt,
    chapter/afterskip = 60pt,
    section/format = \zihao{4}\heiti\raggedright\selectfont,
    subsection/format = \zihao{4}\heiti\raggedright\selectfont,
    subsubsection/format = \zihao{4}\heiti\raggedright\selectfont,
}
\ctexset{
    contentsname = 目录,
    listfigurename = 插图清单,
    listtablename = 表格清单,
}
\cftsetpnumwidth{2em}
\renewcommand{\cftchapleader}{\cftdotfill{\cftchapdotsep}}
\renewcommand{\cftchapdotsep}{\cftdotsep}
\renewcommand{\cftchapfont}{\heiti\zihao{4}}
\setlength{\cftsecindent}{2em}
\setlength{\cftsubsecindent}{52pt}
\setlength{\cftsubsecnumwidth}{2em}
  % 重定义目录命令，修改标题格式并插入书签。
\renewcommand\tableofcontents{%
  \cleardoublepage
  \raggedbottom
  \begingroup
    \ctexset{
      contentsname = {目\hspace{2em}录},
      chapter/format = {\centering\songti\bf\zihao{3}\selectfont},
    }%
    \chapter*{\contentsname}%
  \endgroup
  \addcontentsline{toc}{chapter}{\contentsname}
  \vskip 20pt
  \@starttoc{toc}%
}
\renewcommand\listoffigures{%
  \cleardoublepage
  \begingroup
  \ctexset{
    chapter/format = {\centering\songti\bf\zihao{3}\selectfont},
  }%
  \chapter*{\listfigurename}%
  \endgroup
  \addcontentsline{toc}{chapter}{\listfigurename}
  \vskip 20pt
  \@starttoc{lof}%
}
\renewcommand\listoftables{%
  \cleardoublepage
  \begingroup
  \ctexset{
    chapter/format = {\centering\songti\bf\zihao{3}\selectfont},
  }%
  \chapter*{\listtablename}%
  \endgroup
  \addcontentsline{toc}{chapter}{\listtablename}
  \vskip 20pt
  \@starttoc{lot}%
}
\NewDocumentEnvironment{preface}{}
{%
  \chapter*{前言}
  \addcontentsline{toc}{chapter}{前言}
}{\cleardoublepage}
\NewDocumentEnvironment{acknowledgement}{}
{%
  \chapter*{致谢}
  \addcontentsline{toc}{chapter}{致谢}
}{\cleardoublepage}
\NewDocumentCommand\njupaperlist { t* m }
{
  \begin{refsection}
    \nocite{#2}
    \IfBooleanTF {#1}
    { \printbibliography[heading=subbibliography,title=合作文章目录] }
    { \printbibliography[heading=subbibliography,title=发表文章目录] }
  \end{refsection}
}
\RequirePackage[
    style=gb7714-2015,
    %style=numeric-comp,
    %citestyle=authortitle-icomp,
    % citestyle=numeric-comp,
    %bibstyle=authoryear,
    % bibstyle=numeric,
    sorting=none,
    %sorting=nyt,
    %sortcites=true,
    %autocite=footnote,
    backend=biber, % Compile the bibliography with biber
    hyperref=true,
    backref=false,
    citecounter=true,
    pagetracker=true,
    citetracker=true,
    ibidtracker=context,
    autopunct=true,
    autocite=plain,
    % gbpub=false,         % Uncomment if you do NOT want '[S.l. : s.n.]'
                           % in reference entries, GitHub Issue (#47)
    % gbnamefmt=lowercase, % Uncomment if you do NOT want uppercase author
                           % names in reference entries, GitHub Issue (#23)
]{biblatex}
\AtEveryBibitem{
\clearfield{abstract}
\clearfield{issn}
\clearfield{isbn}
\clearfield{archivePrefix}
\clearfield{arxivId}
\clearfield{pmid}
\clearfield{eprint}
\ifentrytype{online}{}{\ifentrytype{misc}{}{\clearfield{url}}}
}
\crefdefaultlabelformat{#2#1#3\,}

\crefname{figure}{图}{图}
\crefname{table}{表}{表}
\crefformat{equation}{公式~#2#1#3~}

\crefformat{chapter}{第#2#1#3章}
\crefformat{section}{第~#2#1#3~节}
\crefformat{subsection}{第~#2#1#3~小节}
\crefformat{subsubsection}{第~#2#1#3~小节}
\crefname{appendix}{附录}{附录}

\ctex_at_end_preamble:n
{
  \hypersetup
    {
      bookmarksnumbered = true,
      psdextra          = true,
      unicode           = true,
      pdftitle    = \l__nju_info_title_tl,
      pdfauthor   = \l__nju_info_author_tl,
      pdfkeywords = \l__nju_info_keywords_clist,
      pdfcreator  = \c__nju_name_pdf_creator_tl
    }
}
\floatsetup[figure]{ % Captions for figures
capposition=bottom,%
margins=centering,%
floatwidth=\textwidth%
}
\floatsetup[table]{ % Captions for tables
capposition=above,%
margins=centering,%
floatwidth=\textwidth%
}
\DeclareCaptionFont{songticap}{\zihao{5}\bf\songti}
\captionsetup{
  font=small,%
  labelfont=songticap,
textfont=songticap,
strut=no,%
hypcap=true, % Links point to the top of the figure
aboveskip=6pt, % Increase the space between the figure and the caption
belowskip=6pt, % Increase the space between the caption and the table
}
\floatsetup[lstlisting]{ % Captions for lstlistings
capposition=above,%
margins=centering,%
floatwidth=\textwidth%
}
\lstset{
basicstyle=\ttfamily\linespread{1}\small\selectfont,
    keywordstyle=\bfseries,% use bold style for keywords
    commentstyle=\rmfamily\itshape,% use italic style for comments
    stringstyle=\ttfamily,% 字符串风格
    flexiblecolumns,% ?
    numbers=left,% left-aligned numbering
    showspaces=false,% hide markers for spaces
    showstringspaces=false,
    captionpos=t,% place the caption at the top
breaklines=true,
xleftmargin=2em,xrightmargin=2em,% set the width of the code environment
}
\lstdefinestyle{LaTeX}{
  language=TeX,
  morekeywords={
    begin, caption, label, mathrm, frac,
    toprule, midrule, bottomrule, includegraphics}
}
\renewcommand{\labelitemi}{\tiny$\blacktriangleright$}
\renewcommand{\labelitemii}{\textbullet}

\setlist[itemize]{noitemsep}
\setlist[enumerate]{noitemsep}
\setlist[description]{noitemsep}
\NewDocumentCommand\mathbi{m}{\textbf{\em #1}}
\declaretheoremstyle[
     %spaceabove=.5\thm@preskip,
     %spacebelow=.5\thm@postskip,
     headfont=\bf\songti,%\scshape,
     notefont=\songti,% notebraces={ (}{)},
     bodyfont=\songti,
     %headformat={\NAME\space\NUMBER\space\NOTE},
     headpunct={},
     %postheadspace={.5em plus .1em minus .1em},
     %prefoothook={\hfill\qedsymbol}
    ]{njuthm}

\theoremstyle{njuthm}
\let\oldproofname=\proofname
\renewcommand*{\proofname}{\rm\bf\songti{\oldproofname}}
\declaretheorem[
name=算法,
style=njuthm,
refname={算法,算法},
Refname={算法,算法},
]{algorithm}
\declaretheorem[
name=假设,
style=njuthm,
refname={假设,假设},
Refname={假设,假设},
]{assumption}
\declaretheorem[
name=公理,
style=njuthm,
refname={公理,公理},
Refname={公理,公理},
]{axiom}
\declaretheorem[
name=结论,
style=njuthm,
refname={结论,结论},
Refname={结论,结论},
]{conclusion}
\declaretheorem[
name=条件,
style=njuthm,
refname={条件,条件},
Refname={条件,条件},
]{condition}
\declaretheorem[
name=推论,
style=njuthm,
refname={推论,推论},
Refname={推论,推论},
]{corollary}
\declaretheorem[
name=定义,
style=njuthm,
refname={定义,定义},
Refname={定义,定义},
]{definition}
\declaretheorem[
     name=例,
     style=njuthm,
     refname={例,例},
     Refname={例,例},
     % numberwithin=section,
]{example}
\declaretheorem[
name=引理,
style=njuthm,
refname={引理,引理},
Refname={引理,引理},
]{lemma}
\declaretheorem[
name=性质,
style=njuthm,
refname={性质,性质},
Refname={性质,性质},
]{property}
\declaretheorem[
name=命题,
style=njuthm,
refname={命题,命题},
Refname={命题,命题},
]{proposition}
\declaretheorem[
name=注解,
style=njuthm,
refname={注解,注解},
Refname={注解,注解},
]{remark}
\declaretheorem[
name=定理,
style=njuthm,
refname={定理,定理},
Refname={定理,定理},
numberwithin=section,
]{theorem}
\tl_const:Nn \l__nju_info_title_tl
{
  \l__nju_info_title_a_tl
  \l__nju_info_title_b_tl
  \l__nju_info_title_c_tl
}
\tl_new:N \l__nju_info_supv_full_tl
\tl_new:N \l__nju_info_supv_full_en_tl
\tl_set:Nn \l__nju_info_supv_full_tl
{
  \l__nju_info_supv_a_tl\
  \l__nju_info_supv_a_title_tl\ \
  \l__nju_info_supv_b_tl\
  \l__nju_info_supv_b_title_tl
}
\tl_set:Nn \l__nju_info_supv_full_en_tl
{
  \l__nju_info_supv_a_title_en_tl\
  \l__nju_info_supv_a_en_tl\ \
  \l__nju_info_supv_b_title_en_tl\
  \l__nju_info_supv_b_en_tl
}
\tl_new:N \l__nju_name_degree_tl
\tl_new:N \l__nju_name_degree_en_tl
\str_if_eq:NNTF {\l__nju_info_degree_tl} { ug }
{
  % 本科
  \tl_const:Nn \l__nju_name_diploma_tl { 本科 }
  \tl_const:Nn \c__nju_name_title_tl { 题\hfill 目 }

  \tl_const:Nn \c__nju_cover_uline_len_a_tl { 250pt }
  \tl_const:Nn \c__nju_cover_uline_len_b_tl { 90pt }
  \tl_const:Nn \c__nju_cover_uline_font_tl { \songti }
  \tl_const:Nn \c__nju_cover_uline_style_tl { \bf }
  \tl_const:Nn \c__nju_cover_uline_bskip_tl {}

  \tl_const:Nn \c__nju_cover_box_len_tl { 4.2em }

  % 本科强制不打印国家图书馆封面
  \bool_set_false:N \g__nju_nlcover_bool
}
{
  % 本科以外都是研究生
  \tl_const:Nn \l__nju_name_diploma_tl { 研究生 }
  \tl_const:Nn \c__nju_name_title_tl { 论\hfill 文\hfill 题\hfill 目 }

  \tl_const:Nn \c__nju_cover_uline_len_a_tl { 250pt }
  \tl_const:Nn \c__nju_cover_uline_len_b_tl { 14em }
  \tl_const:Nn \c__nju_cover_uline_font_tl { \kaishu }
  \tl_const:Nn \c__nju_cover_uline_style_tl {}
  \tl_const:Nn \c__nju_cover_uline_bskip_tl { \hspace{1em} }

  \tl_const:Nn \c__nju_cover_box_len_tl { 6em }

  % 研究生学位名称
  \str_if_eq:NNTF { \l__nju_info_degree_tl } { phd }
  {
    \tl_set:Nn \l__nju_name_degree_tl { 博士 }
    \tl_set:Nn \l__nju_name_degree_en_tl { Doctor~of~Philosophy }
  }
  {
    \tl_set:Nn \l__nju_name_degree_en_tl { Master }
    \str_if_eq:NNTF { \l__nju_info_degree_tl } { mg }
    { \tl_set:Nn \l__nju_name_degree_tl { 硕士 } }
    { \tl_set:Nn \l__nju_name_degree_tl { 硕士专业 } }
  }
}
\cs_generate_variant:Nn \tl_map_inline:nn       { xn }
\cs_new_protected:Npn \__nju_spread_box:nn #1#2
  {
    \mode_leave_vertical:
    \hbox_to_wd:nn {#1}
      { \tl_map_inline:xn {#2} { ##1 \hfil } \unskip }
  }
\cs_new:Npn \__nju_cover_uline_a:n #1
{
  \uline{\makebox[\c__nju_cover_uline_len_a_tl]
    {\rm\c__nju_cover_uline_font_tl #1 }}
}
\cs_new:Npn \__nju_cover_uline_b:n #1
{
  \uline{\makebox[\c__nju_cover_uline_len_b_tl]
    {\rm\c__nju_cover_uline_font_tl #1 }}
}
\cs_new:Npn \__nju_cover_uline_nl:nn #1 #2
{
  \uline{\makebox[#1]
    {\rm\c__nju_cover_uline_font_tl #2 }}
}
\cs_new:Npn \__nju_cover_box:n #1
{
  \makebox[\c__nju_cover_box_len_tl][s]{
    #1\c__nju_cover_uline_bskip_tl}
}
\str_if_eq:NNTF { \l__nju_info_type_tl } { thesis }
{
  \tl_const:Nn \l__nju_info_type_tl_name
    { \l__nju_name_diploma_tl 毕业论文 }
}
{
  \tl_const:Nn \l__nju_info_type_tl_name
    { \l__nju_name_diploma_tl 毕业设计 }
}
\cs_new_protected:Npn \__nju_cover_title_breakline:
{
  \__nju_cover_box:n {\c__nju_name_title_tl}
  & \__nju_cover_uline_a:n
  { \c__nju_cover_uline_style_tl \l__nju_info_title_a_tl } \\
  \tl_if_empty:NF \l__nju_info_title_b_tl
  {
    \tl_if_empty:NTF \l__nju_info_title_c_tl
      {
        & \__nju_cover_uline_a:n
        {\c__nju_cover_uline_style_tl \l__nju_info_title_b_tl } \\
      }
      {
        & \__nju_cover_uline_a:n
        { \c__nju_cover_uline_style_tl \l__nju_info_title_b_tl } \\
        & \__nju_cover_uline_a:n
        { \c__nju_cover_uline_style_tl \l__nju_info_title_c_tl } \\
      }
  }
}
\cs_new_protected:Npn \__nju_print_covertab:
{%
  \str_if_eq:NNTF { \l__nju_info_degree_tl } { ug }
  {
    \begin{tabular}{p{4.2em}c}
      \__nju_cover_box:n {院\hfill 系}
      & \__nju_cover_uline_a:n  {\l__nju_info_dept_tl} \\
      \__nju_cover_box:n {专\hfill 业}
      & \__nju_cover_uline_a:n  {\l__nju_major_tl} \\
      \__nju_cover_title_breakline:
    \end{tabular}\\

    \begin{tabular}{p{4.2em}cp{4.2em}c}
      \__nju_cover_box:n {年\hfill 级}
      & \__nju_cover_uline_b:n {\l__nju_info_grade_tl}
      & \__nju_cover_box:n {学\hfill 号}
      & \__nju_cover_uline_b:n {\l__nju_info_id_tl}\\
    \end{tabular}\\

    \begin{tabular}{p{4.2em}c}
      \__nju_cover_box:n {学\hfill 生\hfill 姓\hfill 名}
      & \__nju_cover_uline_a:n  {\l__nju_info_author_tl}
    \end{tabular}\\
    \begin{tabular}{p{4.2em}cp{4.2em}c}
      \__nju_cover_box:n {导\hfill 师}
      & \__nju_cover_uline_b:n {\l__nju_info_supv_a_tl}
      & \__nju_cover_box:n {职\hfill 称}
      & \__nju_cover_uline_b:n {\l__nju_info_supv_a_title_tl}\\

      % 第二导师
      \tl_if_empty:NF \l__nju_info_supv_b_tl
      {
        \__nju_cover_box:n {第\hfill 二\hfill 导\hfill 师}
        & \__nju_cover_uline_b:n {\l__nju_info_supv_b_tl}
        & \__nju_cover_box:n {职\hfill 称}
        & \__nju_cover_uline_b:n {\l__nju_info_supv_b_title_tl}\\
      }
    \end{tabular}\\

    \begin{tabular}{p{4.2em}c}
      \__nju_cover_box:n {提\hfill 交\hfill 日\hfill 期}
      & \__nju_cover_uline_a:n  {\l__nju_submit_date_tl}\\
    \end{tabular}
  }
  {
    \begin{tabular}{p{6em}c}
      \__nju_cover_title_breakline:
      \__nju_cover_box:n {作\hfill 者\hfill 姓\hfill 名}
      & \__nju_cover_uline_a:n  {\__nju_spread_box:nn {4em}{\l__nju_info_author_tl}}\\
      \__nju_cover_box:n {专\hfill 业\hfill 名\hfill 称}
      & \__nju_cover_uline_a:n  {\l__nju_major_tl}\\
      \__nju_cover_box:n {研\hfill 究\hfill 方\hfill 向}
      & \__nju_cover_uline_a:n  {\l__nju_field_tl}\\
      \__nju_cover_box:n {指\hfill 导\hfill 教\hfill 师}
      & \__nju_cover_uline_a:n  {\l__nju_info_supv_full_tl}\\
    \end{tabular}
  }
}
\cs_new_protected:Npn \__nju_print_cover_nl:
{
  \thispagestyle{empty}
  \pdfbookmark[0]{国家图书馆封面}{nl}
  {
    % 顶端
    \noindent\null\vskip -20mm \hskip -15mm
    \songti\zihao{-4}
    \makebox[40pt][l]{分类号}
    \__nju_cover_uline_b:n {\l__nju_info_clc_tl}
    \hfill
    \makebox[40pt][l]{密级}
    \__nju_cover_uline_b:n {\l__nju_info_seclv_tl}
    \vskip 10pt \hskip -15mm
    \makebox[40pt][l]{udc}
    \__nju_cover_uline_b:n {\l__nju_info_udc_tl}
  }

  % 中部
  \vskip\stretch{2}
  \begin{center}
    \def\ULthickness{1pt}
    {\kaishu\zihao{-0} 学\hspace{0.5em}位\hspace{0.5em}论\hspace{0.5em}文}
    {
      \kaishu\zihao{1}
      \vskip \stretch{1}
      \__nju_cover_uline_b:n {\l__nju_info_title_a_tl}\\
      \__nju_cover_uline_b:n {\l__nju_info_title_b_tl}\\
      \__nju_cover_uline_b:n {\l__nju_info_title_c_tl}\\
    }
    \vskip \stretch{1}
    {\kaishu\zihao{4}（题名和副题名）}
    \vskip \stretch{1} \vskip 5mm
    {\kaishu\zihao{1}\uline{\makebox{\l__nju_info_author_tl}}}
    \vskip \stretch{1}
    {\kaishu\zihao{4}（作者姓名）}
  \end{center}

  % 底部
  \vskip\stretch{1}\kaishu\zihao{4}
  \noindent 指导教师姓名、职务、职称、学位、单位名称及地址%
  \__nju_cover_uline_nl:nn {94pt}{\l__nju_info_supv_a_tl}\par
  \noindent \__nju_cover_uline_nl:nn {\textwidth}{%
  \l__nju_info_supv_cont_tl}\par
  \noindent 申请学位级别%
  \__nju_cover_uline_nl:nn {9em}{\l__nju_name_degree_tl}%
  \noindent 专业名称%
  \uline{\hfill\l__nju_major_tl\hfill}\par
  \noindent 论文提交日期%
  \__nju_cover_uline_nl:nn {9em}{\l__nju_submit_date_tl}%
  \noindent 论文答辩日期%
  \uline{\hfill\l__nju_defend_date_tl\hfill}\par
  \noindent 学位授予单位和日期\uline{\hfill}\par
  \begin{flushright}
    答辩委员会主席：
    \__nju_cover_uline_nl:nn {9em}{ \l__nju_info_chairman_tl }\par
    评阅人：
    \__nju_cover_uline_nl:nn {9em}
      { \clist_item:Nn \l__nju_info_reviewer_clist {1} }\par
    \__nju_cover_uline_nl:nn {9em}
      { \clist_item:Nn \l__nju_info_reviewer_clist {2} }\par
    \__nju_cover_uline_nl:nn {9em}
      { \clist_item:Nn \l__nju_info_reviewer_clist {3} }\par
    \__nju_cover_uline_nl:nn {9em}
      { \clist_item:Nn \l__nju_info_reviewer_clist {4} }\par
  \end{flushright}
  \begin{center}
    \kaishu\zihao{3}\hspace{2em} 年\hspace{1em} 月\hspace{1em} 日
  \end{center}
  \vskip -10mm
  \cleardoublepage
}
\cs_new_protected:Npn \__nju_print_cover_ug:
{
  \thispagestyle{empty}
  \pagenumbering{Roman}
  % Start
  \pdfbookmark{封面}{cover} % 将封面插入pdf书签
  \begin{spacing}{1.25}
  \noindent\null\hspace{-10mm}
  \njuemblem{!}{3cm}\smallskip
  \begin{center}
    \njuname{!}{3.35cm}
    \vskip 10mm
    {\zihao{1}\bf\songti\__nju_spread_box:nn {9em}{\l__nju_info_type_tl_name}}
    \vfill
    \vskip\stretch{0}
    {\bgroup
    \kaishu\zihao{3}
    \def\tabcolsep{1pt}
    \def\arraystretch{1.5}
    % 绘制信息框
    \__nju_print_covertab:
    \egroup}
    \vfill
  \end{center}
  \end{spacing}
  \cleardoublepage
}
\cs_new_protected:Npn \__nju_print_cover_g:
{
  \thispagestyle{empty}
  \pagenumbering{Roman}
  % Start
  \pdfbookmark{封面}{cover} % 将封面插入pdf书签
  \begin{spacing}{1.25}
  \begin{center}
    \noindent\null\vskip 5mm
    \njuemblem{!}{1.9cm}
    \vskip 10mm
    \njuname{4.4cm}{!}
    \par\vskip -2mm
    \njuname*{4.4cm}{!}
    \vskip 15mm
    \bgroup
      \zihao{1}\bf\kaishu
      \__nju_spread_box:nn {10em}{\l__nju_info_type_tl_name}
      \vskip 5mm
      {（申请\l__nju_name_degree_tl 学位）}
    \egroup
    \par\vfill\vskip\stretch{0}
    \bgroup
      \bf\kaishu\zihao{3}
      \def\tabcolsep{1pt}
      \def\arraystretch{1.5}
      \vskip 10mm
      \__nju_print_covertab:
    \egroup
    \vfill
    \vskip 10mm
    \bf\kaishu\zihao{4}\l__nju_submit_date_tl
    \vskip 15mm
  \end{center}
  \end{spacing}

  \newpage % 封面背面
  \thispagestyle{empty}
  \begin{spacing}{1.625}
    % TODO: 等待调整格式
    \null\vfill
    {\bgroup
    \kaishu\zihao{3}
    \makebox[6em][s]{\bf\kaishu 学\hfill 号}：\MakeUppercase{\l__nju_info_id_tl}
    \par
    \makebox[6em][s]{\bf\kaishu 论文答辩日期}：\l__nju_defend_date_tl
    \par
    \makebox[6em][s]{\bf\kaishu 指\hfill 导\hfill 教\hfill 师}：\hspace{50mm}（签字）
    \par
    \egroup}
    \vskip 15mm
  \end{spacing}
  \cleardoublepage
}
\cs_new_protected:Npn \__nju_print_cover_en:
{
  \thispagestyle{empty}
  \pdfbookmark{英文封面}{cover-en} % 将封面插入pdf书签
  \begin{center}
    \noindent\vspace*{20pt}
    \bf\sffamily\zihao{2}\l__nju_info_title_en_tl
    \vskip \stretch{1}
    \normalfont\rmfamily\zihao{4}{by}
    \vskip 3pt
    \bf\sffamily\zihao{4}\l__nju_info_author_en_tl
    \vskip\stretch{1}
    \normalfont\rmfamily\zihao{4}{Supervised~by}
    \vskip 3pt
    \normalfont\sffamily\zihao{4}
    \l__nju_info_supv_a_title_en_tl
    \hspace{.5em}\l__nju_info_supv_a_en_tl\\
    \l__nju_info_supv_b_title_en_tl
    \hspace{.5em}\l__nju_info_supv_b_en_tl
    \vskip\stretch{1}
    \normalsize\rmfamily{%
      A~dissertation~submitted~to\\
      the~graduate~school~of~Nanjing~University\\
      in~partial~fulfilment~of~the~requirements~for~the~degree~of\\
      {\textsc{\l__nju_name_degree_en_tl}}\\
      in\\
      {\l__nju_major_en_tl}
    }
    \vskip\stretch{2}
    \njuemblem{2.5cm}{!}\par
    \vskip 3mm
    \normalfont\l__nju_info_dept_en_tl\\
    {Nanjing~University}
    \vskip 30pt
    \normalfont\normalsize\l__nju_submit_date_en_tl
  \end{center}
  \normalfont
  \cleardoublepage
}
\tl_set:Nn \maketitle
{%
  \str_if_eq:NNTF { \l__nju_info_degree_tl } { ug }
  {
    \__nju_print_cover_ug: % 本科封面
  }
  {
    \bool_if:NT \g__nju_nlcover_bool { \__nju_print_cover_nl: } % 国家图书馆封面
    \__nju_print_cover_g: % 研究生封面
    \__nju_print_cover_en: % 英文封面
  }
}
\cs_new_protected:Npn \__nju_print_keywords:
{
  \par\vspace{2ex}
  \bgroup
    \noindent
    \c__nju_name_keywords_tl
    \clist_use:Nn \l__nju_info_keywords_clist {；}
    \par
  \egroup
}
\cs_new_protected:Npn \__nju_print_keywords_en:
{
  \par\vspace{2ex}
  \bgroup
    \noindent
    \c__nju_name_keywords_en_tl\hspace{0.5em}
    \clist_use:Nn \l__nju_info_keywords_en_clist {；}
    \par
  \egroup
}
\cs_new_protected:Npn \__nju_print_abstract_ug:
{
  \thispagestyle{plain}
  \pdfbookmark[0]{中文摘要}{abstract-zh}
  \begin{center}
    \kaishu\zihao{-2}{\textbf{
      \uuline{南京大学本科生毕业论文（设计、作品）中文摘要}}}
  \end{center}
  \bgroup
    \noindent\kaishu\zihao{-4}
    题目： \l__nju_info_title_tl \\
    院系： \l__nju_info_dept_tl \\
    专业： \l__nju_major_tl \\
    本科生姓名： \l__nju_info_author_tl \\
    指导教师（姓名、职称）：\l__nju_info_supv_full_tl \\
    摘要：
  \egroup
  \kaishu\zihao{-4}\par%
}
\cs_new_protected:Npn \__nju_print_abstract_en_ug:
{
  \thispagestyle{plain}
  \pdfbookmark[0]{英文摘要}{abstract-en}
  \begin{center}
      \kaishu\zihao{-2}{\textbf{\uuline{
        南京大学本科生毕业论文（设计、作品）英文摘要}}}
  \end{center}
  {
    \bgroup
    THESIS: ~~\l__nju_info_title_en_tl \\
    DEPARTMENT: ~~\l__nju_info_dept_en_tl \\
    SPECIALIZATION: ~~\l__nju_major_en_tl \\
    UNDERGRADUATE:~~\l__nju_info_author_en_tl \\
    MENTOR:~~\l__nju_info_supv_full_en_tl \\
    ABSTRACT:
    \egroup
  }
  \zihao{-4}\par%
}
\cs_new_protected:Npn \__nju_print_abstract_g:
{
  \thispagestyle{plain}
  \pdfbookmark[0]{中文摘要}{abstract-zh}
  \begin{center}
    \kaishu\zihao{-2}{\textbf{\uuline{
      南京大学研究生毕业论文中文摘要首页用纸}}}
  \end{center}
  \bgroup
    \noindent\kaishu\zihao{4}
    毕业论文题目：\hspace{0.5em}\njuline{\l__nju_info_title_tl\hfill}\\
    \njuline{\makebox[11em]{\l__nju_major_tl}}专业
    \njuline{\makebox[4em]{\l__nju_info_grade_tl}}级
    \str_if_eq:NNTF {\l__nju_info_degree_tl} { phd } {博}{硕}
    士生姓名：\njuline{\hfill\l__nju_info_author_tl\hfill}\\
    指导教师（姓名、职称）：\njuline{\hfill\l__nju_info_supv_full_tl\hfill}\par
  \egroup
  \kaishu\zihao{4}\par%
}
\cs_new_protected:Npn \__nju_print_abstract_en_g:
{
  \thispagestyle{plain}
  \pdfbookmark[0]{英文摘要}{abstract-en}
  \begin{center}
      \kaishu\zihao{-2}{\textbf{\uuline{
        南京大学研究生毕业论文英文摘要首页用纸}}}
  \end{center}
  {
    \bgroup
    \zihao{4}
    THESIS: ~~\l__nju_info_title_en_tl \\
    SPECIALIZATION: ~~\l__nju_major_en_tl \\
    POSTGRADUATE:~~\l__nju_info_author_en_tl \\
    MENTOR:~~\l__nju_info_supv_full_en_tl\par
    \egroup
  }
  \zihao{4}\par%
}
\str_if_eq:NNTF {\l__nju_info_degree_tl} { ug }
{
  \NewDocumentEnvironment{abstract} {}
  {\__nju_print_abstract_ug:}{\__nju_print_keywords:\newpage}
  \NewDocumentEnvironment{abstract*} {}
  {\__nju_print_abstract_en_ug:}{\__nju_print_keywords_en:\cleardoublepage}
}
{
  \NewDocumentEnvironment{abstract} {}
  {\__nju_print_abstract_g:}{\__nju_print_keywords:\newpage}
  \NewDocumentEnvironment{abstract*} {}
  {\__nju_print_abstract_en_g:}{\__nju_print_keywords_en:\cleardoublepage}
}
\endinput
%%
%% End of file `njuthesis.cls'.
